#
# TODO: enter JYTHON code and save
#
import sys, java

lineSeparator = java.lang.System.getProperty('line.separator')

def setDB2WASVar(driverPath,nodeName):
   varName = "DB2UNIVERSAL_JDBC_DRIVER_PATH"
   
   node = AdminConfig.getid("/Node:" + nodeName)

   varSubstitutions = AdminConfig.list("VariableSubstitutionEntry",node).split(java.lang.System.getProperty("line.separator"))

   for varSubst in varSubstitutions:
      getVarName = AdminConfig.showAttribute(varSubst, "symbolicName")
      if getVarName == varName:
         AdminConfig.modify(varSubst,[["value", driverPath]])
         break

def setOracleWASVar(driverPath,nodeName):
   varName = "ORACLE_JDBC_DRIVER_PATH"
   
   node = AdminConfig.getid("/Node:" + nodeName)

   varSubstitutions = AdminConfig.list("VariableSubstitutionEntry",node).split(java.lang.System.getProperty("line.separator"))

   for varSubst in varSubstitutions:
      getVarName = AdminConfig.showAttribute(varSubst, "symbolicName")
      if getVarName == varName:
         AdminConfig.modify(varSubst,[["value", driverPath]])
         break


def setMSSQLWASVar(driverPath,nodeName):
   varName = "MSSQLSERVER_JDBC_DRIVER_PATH"
   
   node = AdminConfig.getid("/Node:" + nodeName)

   varSubstitutions = AdminConfig.list("VariableSubstitutionEntry",node).split(java.lang.System.getProperty("line.separator"))

   for varSubst in varSubstitutions:
      getVarName = AdminConfig.showAttribute(varSubst, "symbolicName")
      if getVarName == varName:
         AdminConfig.modify(varSubst,[["value", driverPath]])
         break


def configureDBAccess(serverName, dbType, templateName, providerName, driverPath, dsName, dbName, hostName, db2account, db2password, dbPortNumber):

   #--------------------------------------------------------------
   # set up globals
   #--------------------------------------------------------------
   global AdminConfig

   nodeName = AdminControl.getNode()

   JNDI_NAME = "jdbc/RAM_Con"
   ALIAS_NAME = nodeName + '/' + 'ramAlias'

   print "configureDBAccess, running with: "
   print "	Node name: " + nodeName
   print "	DB Type: " + dbType
   print "	Server name: " + serverName
   print "	JDBC Provider Template Name: " + templateName
   print "	Name of JDBC Provider to create: " + providerName
   print "	Path to DB2 JDBC Driver: " + driverPath
   print "	Data source name: " + dsName
   print "	Data source JNDI name " + JNDI_NAME
   print "	Database name: " + dbName
   print "	Database server hostname: " + hostName
   print "	Database server port number: " + dbPortNumber
   print "	Database Administrator account: " + db2account
   print "	Database Administrator password: " + db2password

   
   
   #create the authentication alias
   security = AdminConfig.getid('/Security:/')
   alias = ['alias', ALIAS_NAME]
   userId = ['userId', db2account]
   password = ['password',db2password]
   jaasAttrs = [alias, userId, password]
   
   AdminConfig.create('JAASAuthData', security, jaasAttrs)

   #---------------------------------------------------------
   # Get the config id for a JDBC Template
   # Use "lindex" in case there is more than one matching templates -- we
   # just get the first one. 
   #---------------------------------------------------------
   print "configureDBAccess: getting the JDBCProvider template whose name is " +  templateName
   
   #the '(' is needed because the array may have more than one element
   template = AdminConfig.listTemplates("JDBCProvider", templateName + '(').split(lineSeparator)[0]
   if len(template) == 0:
      print "configureDBAccess: could not find a JDBCProvider template using " + templateName
      return
 
   print template
 
   #---------------------------------------------------------
   # Get the config id for the server 
   #---------------------------------------------------------
   print "configureDBAccess: getting the confid id for server " + serverName 
   node = AdminConfig.getid("/Server:" + serverName + "/")
   if len(node) == 0:
      print "configureDBAccess: could not find server " + serverName
      return
 
   print node
 
   #---------------------------------------------------------
   # Create a new JDBCProvider using this template 
   #---------------------------------------------------------
   print "configureDBAccess: create a new JDBCProvider object named " + providerName
 
   nameAttr = ["name", providerName]
   attrs = []
   attrs.append(nameAttr)
   new1 = AdminConfig.createUsingTemplate("JDBCProvider", node, attrs, template)
 
   print new1

   if dbType == 'DB2':
   	#set the DB2 Universal JDBC driver path so datasources will work
   	setDB2WASVar(driverPath,nodeName)

   if dbType == 'Oracle':
   	#set the Oracle JDBC driver path so datasources will work
	setOracleWASVar(driverPath,nodeName)
   
   if dbType == 'MSSQL':
   	#set the MS SQL JDBC driver path so datasources will work
   	setMSSQLWASVar(driverPath,nodeName)

   
 
   #---------------------------------------------------------
   # Remove WAS40DataSource cruft added by template
   #---------------------------------------------------------
   print "configureDBAccess: remove the WAS40DataSource object created via the template"
   was40ds = AdminConfig.getid("/JDBCProvider:" + providerName + "/WAS40DataSource:/")
   AdminConfig.remove(was40ds)
    
   #--------------------------------------------------------------
   # Modify the DataSource - give it a name and a jndiName, and remove 
   # existing properties created by the template
   # A collection of objects (such as the resourceProperties attribute of the
   # propertySet attribute) can only be added to.  To completely replace
   # the collection you need to delete the old one first.
   #--------------------------------------------------------------
   print "configureDBAccess: modify the datasource object -- name, jndiName; remove old properties."
   ds = AdminConfig.getid("/JDBCProvider:" + providerName + "/DataSource:/")
   nameAttr = ["name", dsName]
   authDataAlias = ['authDataAlias', ALIAS_NAME]
   jndiNameAttr = ["jndiName", JNDI_NAME]

   #this should get the first RRA from the config
   rrAdapter = AdminConfig.list('J2CResourceAdapter').split(lineSeparator)[0]
   rra = ["relationalResourceAdapter", rrAdapter]
 
   psAttr = ["propertySet", []]
   attrs = []
   attrs.append(nameAttr)
   attrs.append(jndiNameAttr)
   attrs.append(psAttr)
   attrs.append(authDataAlias)
   attrs.append(rra)
   AdminConfig.modify(ds, attrs)
   
    
   #--------------------------------------------------------------
   # Add desired properties to the DataSource.
   #--------------------------------------------------------------
   print "configureDBAccess: modify the datasource object -- name, jndiName, properties."
   
   newsprops = []

   if dbType == 'DB2':
   	dbnameAttr = [["name", "databaseName"], ["value", dbName], ["type", "java.lang.String"]]
	driverTypeAttr = [["name", "driverType"], ["value", 4], ["type", "java.lang.Integer"]]
   	serverAttr = [["name", "serverName"], ["value", hostName], ["type", "java.lang.String"]]
   	portNumberAttr = [["name", "portNumber"], ["value", dbPortNumber], ["type", "java.lang.Integer"]]
   	
	newsprops.append(dbnameAttr) 
	newsprops.append(driverTypeAttr) 
   	newsprops.append(serverAttr)
   	newsprops.append(portNumberAttr)
   	
   if dbType == 'Oracle':
	OracleURLArgs = "jdbc:oracle:thin:@" + hostName + ":" + dbPortNumber + ":" + dbName
   	OracleURLAttrdriverTypeAttr = [["name", "URL"], ["value", OracleURLArgs], ["type", "java.lang.String"]]
	newsprops.append(OracleURLAttrdriverTypeAttr)
   
   if dbType == 'MSSQL':
   	dbnameAttr = [["name", "databaseName"], ["value", dbName], ["type", "java.lang.String"]]
     	serverAttr = [["name", "serverName"], ["value", hostName], ["type", "java.lang.String"]]
  	portNumberAttr = [["name", "portNumber"], ["value", dbPortNumber], ["type", "java.lang.Integer"]]
	enable2PhaseAttr = [["name", "enable2Phase"], ["value", "false"], ["type", "java.lang.Boolean"]]
   	
	
	newsprops.append(dbnameAttr) 
   	newsprops.append(serverAttr)
   	newsprops.append(portNumberAttr)
	newsprops.append(enable2PhaseAttr)


   psAttr = ["propertySet", [["resourceProperties", newsprops]]]
   attrs = [psAttr]
   AdminConfig.modify(ds, attrs)
   print AdminConfig.showall(ds)

   AdminConfig.save()
   #the server should be restarted before trying to use the datasource


#-----------------------------------------------------------------
# Main
#-----------------------------------------------------------------
if (len(sys.argv) != 11):
   print "configureDBAccess: this script requires 8 parameters: " 
   print "       1) the name of the server under which to create resources,"
   print "       2) The Database Type,"
   print "       3) the name of a JDBCProvider template to use,"
   print "       4) the name of the JDBCProvider to create,"
   print "       5) the fully-qualified path to the DB2 driver jars,"
   print "       6) the name of the datasource to create,"
   print "       7) the name of the database to use,"
   print "       8) and the hostname of the database server."
   print "       9) DB2 user account."
   print "      10) DB2 user password."
   print "      11) The Database server Port Number."
   print ""
   print "e.g.:     configureDBAccess server1 DB2 \"DB2 Universal JDBC Driver Provider\" myprovider c:/SQLLIB/java/ myds sampleDB localhost db2admin M0re4svt 50000"
else:
   configureDBAccess(sys.argv[0], sys.argv[1], sys.argv[2], sys.argv[3], sys.argv[4], sys.argv[5], sys.argv[6], sys.argv[7], sys.argv[8], sys.argv[9], sys.argv[10])

